// ***********************************************************************
// *
// 
//  CPRAdaptor.js
//
// Licensed Materials - Property of IBM
//  5724-W86, 5724-X63
//   Copyright IBM Corporation 2006,2012. All Rights Reserved.
//  US Government Users Restricted Rights- Use, duplication or disclosure
//  restricted by GSA ADP Schedule Contract with IBM Corp.
// *
// ***********************************************************************
// *
// * $Id$
// *



// ***********************************************************************
// * INIT GLOBAL VARIABLES DECLARATION
// ***********************************************************************

// used for the date conversion
var laststringdate = "";
var lastdateobject;
var lastMessage = '';
var entityType;
var element;
var subelement;
var labelArray;
var labelHash;
var storeDev = new Object();
var storeDev_initialized = false;
//var devMetArray;


var DEBUG = "false";

var LOG_TYPE = ( PV.configuration.RUNINTERVAL / 60 );
// ***********************************************************************
// * TRACES SETUP - Used for debugging
// ***********************************************************************

function logMessage(type, logdata) {
   if ( DEBUG == "true" ) {
       //      PV.Logger.logDebug("DEBUG", type, logdata);
      //PV.Logger.logInfo("DEBUG", type, logdata);
   }
}


logMessage("STATUS", "Beginning CPRAdaptor...");




// ***********************************************************************
// Function: processRecord
// Inputs  : A record from the input file
// Outputs : Populates the prevRecsArray
// Returns : None
// Purpose : Creates subelements/metrics based upon preProcessed records
// ***********************************************************************


/*
function extractValue(rec, mname) {
	var value;
   for ( var m in rec.labelArray ) {
       if ( rec.labelArray[m] == mname ) {
           value = rec.valueArray[m];
		if (value != '') {
        	   return rec.valueArray[m];
       		}
	}
   }
   return undefined;
     
}

*/

function labelHashInit(rec) {

    labelHash = new Object();
    for ( var m in rec.fields ) {
	labelHash[rec.fields[m]]=m;
	//PV.Logger.logInfo("labelHashInit", "labelHashInit", "label: " + rec.fields[m] +" index: " +m);
    }

}


function extractValue(rec, mname) {
    var index=-1, value;
    index=rec.labelHash[mname];
    if (index >= 0) {
	value = rec.fields[index];
	//PV.Logger.logInfo("extractValue", "extractValue", "label: " + mname + " index: " + index + " value: " + value);
	if (value != '') {
	    return value;
	}
    }

    return undefined;
     
}
   

// ***********************************************************************
// *  This is added stuff the new Array with the PVGDevice metrics
// *  
// * - Luis Jan 2012

function storeDevValue(rec, metricname, inputtype, value)  {
	//var storeDev = new Array();

        var sename;
        var storedValue = 0;

	if ( value == 0 || value > 0 ) {
	   sename  = rec.element + "_Device";

	//PV.Logger.logInfo("STOREDEV_DEBUG0:", "This is what is in the Value : " + value);
	//PV.Logger.logInfo("STOREDEV_DEBUG0A:", "This is what is in the metricname : " + metricname);
	if (storeDev[sename] == undefined) 
		{ 
	//PV.Logger.logInfo("STOREDEV_DEBUGB: creating new se entry for: ", " : " + sename);
		    
	          storeDev_initialized = true;

	          storeDev[sename] = new Object();
		  storeDev[sename].metrics = new Object();
		  storeDev[sename].propertiess = new Object();
		  storeDev[sename].name = sename;
		  storeDev[sename].element = rec.element;
		  storeDev[sename].timestamp = rec.timestamp;

		  //PV.Logger.logInfo("STOREDEV_DEBUG0A:", "DUMPING the STOREDEV", storeDev.toString());

		  
		}
	//PV.Logger.logInfo("STOREDEV_DEBUG1:", "This is what is in the sename: " + storeDev[sename].name);

	if (inputtype != "property") {
	    if (storeDev[sename].metrics[metricname] == undefined ) 
		{ 
		    storeDev[sename].metrics[metricname] =  Number(value);
		}
	    else
		{ 
		    storedValue = storeDev[sename].metrics[metricname]; 
		    
		    //PV.Logger.logInfo("STOREDEV_DEBUG3:", "This is what is in the storedValue : " + storedValue);
		    var newValue = Number(value) + storedValue;
		    storeDev[sename].metrics[metricname] = newValue;
		    
		    //PV.Logger.logInfo("STOREDEV_DEBUG2:", "This is what is in the metricname: " + metricname);
		    //	PV.Logger.logInfo("STOREDEV_DEBUG2:", "This is what is in the value of metricname: " + storeDev[sename].metrics[metricname]);
		    //PV.Logger.logInfo("STOREDEV_DEBUG4:", "This is what is in the current value : " + storedValue);
		    //PV.Logger.logInfo("STOREDEV_DEBUG5:", "This is what is in the newValue : " + newValue);
		    
		}
	} // not a property (is a metric)
	else { // is a property
	    storeDev[sename].properties[metricname] = value;
	}
	}

}



var deviceMetrics = {
    SessionServer:  {
             properties: { VOIPSoftswitchComponentType: "SS-T", VOIPSoftswitchVendor: "Nortel",
                           VOIPSoftswitchLocation: "Unknown" },
             filter: function(rec) { if ( findLabel("LINKID") != 1 || ((rec.entityType.indexOf("PVG") == -1) && (rec.entityType.indexOf("VGS") == -1))  ) return 1; },
             genSeName: function(rec) { return rec.element + "_Device"; },
             formulaPath: "AP~Specific~Bulk~Carrier VOIP~Infrastructure~SessionServer",
             Formulas: {
                  Processor: {  method: function(rec) { return extractValue(rec, "Average CPU Usage") } },
                  SimultaneousCalls: {  method: function(rec) { return extractValue(rec, "SIMULTANEOUS_CALL_HWM") } },
                  CallVolumeForTheSSTnode: {  method: function(rec) { return extractValue(rec, "NODAL_NPI_CALL_VOL") } },
                  CallsReleasedBySST: {  method: function(rec) { return extractValue(rec, "NODAL_NPI_MID_CALL_FAIL") } },
                  FERserverNERforTheSSTnode: {  method: function(rec) { return extractValue(rec, "NODAL_NPI_SIPGW_FER_NER") } },
                  FERserverNERforTheSSTnetwork: {  method: function(rec) { return extractValue(rec, "NETWORK_NPI_SIPGW_FER_NER") } },
                  LocalGWCNERforTheSSTnode: {  method: function(rec) { return extractValue(rec, "NODAL_NPI_SIPGW_GWC_NER") } },
                  LocalGWCNERforTheSSTnetwork: {  method: function(rec) { return extractValue(rec, "NETWORK_NPI_SIPGW_GWC_NER") } },
                  FERserverCCRforTheSSTnode: {  method: function(rec) { return extractValue(rec, "NODAL_NPI_SIPGW_FER_CCR") } },
                  LocalGWCCCRforTheSSTnode: {  method: function(rec) { return extractValue(rec, "NODAL_NPI_SIPGW_GWC_CCR") } },
                  FERserverMHTforTheSSTnode: {  method: function(rec) { return extractValue(rec, "NODAL_NPI_MEAN_HLD_TIME_FER") } },
                  LocalGWCMHTforTheSSTnode: {  method: function(rec) { return extractValue(rec, "NODAL_NPI_MEAN_HLD_TIME_GWC") } },
                  FERserverMTTforTheSSTnode: {  method: function(rec) { return extractValue(rec, "NODAL_NPI_MEAN_TALK_TIME_FER") } },
                  LocalGWCMTTforTheSSTnode: {  method: function(rec) { return extractValue(rec, "NODAL_NPI_MEAN_TALK_TIME_GWC") } },
                  InboundInvitePostDialDelay: {  method: function(rec) { return extractValue(rec, "NODAL_NPI_PDD_IC_INV") } },
                  OutboundInvitePostDialDelay: {  method: function(rec) { return extractValue(rec, "NTWK_NPI_PDD_OG_INV") } }
              }
     },
     PVGDevice:  {
	properties: { VOIPSoftswitchComponentType: function(rec, metricname) { return storeDevValue(rec,metricname,"property", "Media_Gateway_Device")},
		      VOIPSoftswitchVendor: function(rec, metricname) { return storeDevValue(rec,metricname,"property", "Nortel")},
		      VOIPSoftswitchLocation: function(rec,metricname) { return storeDevValue(rec, metricname, "property", extractValue(rec, "OFFICEID")) } },
	//			   VOIPSoftswitchVendor: "Nortel",
	//                           VOIPSoftswitchLocation: function(rec) { return extractValue(rec, "OFFICEID") } },
             filter: function(rec) { if ( findLabel("LINKID") ) return 1; },
             formulaPath: "AP~Specific~Bulk~Carrier VOIP~Infrastructure~Media Gateway~Device",
             genSeName: function(rec) { return getSubelementName(rec.element, extractValue(rec, "LINKID"), "PVGDevice" ) },
             Formulas: {
                  AvgCPUutilizationCardProcessing: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric", (extractValue(rec, "CARDUTILAVG"))) } },
                  AvgCPUutilizationVSPCard: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric", (extractValue(rec, "VSPUTILAVG"))) } },
                  TotalPackets: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric", (myMetricSum(extractValue(rec, "INPACKETS"), extractValue(rec, "OUTPACKETS")))) } },
                  TotalTCPPackets: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric", (myMetricSum(extractValue(rec, "INTCPPACKETSLOCAL"), extractValue(rec, "OUTTCPPACKETSLOCAL")))) } },
                  TotalUDPPackets: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric", (myMetricSum(extractValue(rec, "INUDPPACKETSLOCAL"), extractValue(rec, "OUTUDPPACKETSLOCAL")))) } },
                  TotalICMPPackets: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric", (myMetricSum(extractValue(rec, "INICMPPACKETSLOCAL"), extractValue(rec, "OUTICMPPACKETSLOCAL")))) } },
                  TotalDiscardedPackets: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric", (myMetricSum(extractValue(rec, "INPACKETSDIS"), extractValue(rec, "OUTPACKETSDIS")))) } },
                  TotalPacketExceptions: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric", (myMetricSum(extractValue(rec, "INLOCALEXCEPTIONS"), extractValue(rec, "INFWDEXCEPTIONS")))) } },
                  CongestedSeconds: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric", (extractValue(rec, "CONGSECS"))) } },
                  H248Retransmission: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric", (myMetricSum(extractValue(rec, "INH248RETRAN"), extractValue(rec, "OUTH248RETRAN")))) } },
                  TotalActiveCalls: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric", (extractValue(rec, "ACTIVECALLAVG"))) } },
                  TotalSuccessfulCalls: { method: function(rec, metricname) { if ( extractValue(rec, "ACTIVECALLAVG") && LOG_TYPE ) return storeDevValue(rec, metricname, "metric", (extractValue(rec, "ACTIVECALLAVG") * LOG_TYPE * 60 )) } },
                  TDMCallFailures: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric", (extractValue(rec, "CALLFAILTDM"))) } },
                  NetworkCallFailure: { method: function(rec, metricname) { return storeDevValue(rec. metricname, "metric",  (extractValue(rec, "CALLFAILSNET"))) } },
                  Failovers: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric",  (extractValue(rec, "FAILOVERS"))) } },
                  OverloadCmdRejected: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric",  (extractValue(rec, "OVLDCMDSREJECTED"))) } },
                  OutboundCallFailures: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric", (sumCallFailures(rec, "out"))) } },
                  InboundCallFailures: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric",  (sumCallFailures(rec, "in"))) } },
                  TotalMinutesOfUse: { method: function(rec, metricname) { return storeDevValue(rec, metricname, "metric",( extractValue(rec, "ACTIVECALLAVG") * LOG_TYPE )) } }
              }
      },
      PVGFabricCard: {
              properties: { VOIPSoftswitchComponentType: "Media_Gateway_FabricCard", VOIPSoftswitchVendor: "Nortel",
                            VOIPSoftswitchLocation: function(rec) { return extractValue(rec, "OFFICEID") } },
              filter: function(rec) { var link = extractValue(rec, "LINKID"); logMessage("FILTER", link); if ( link != undefined ) { if ( link.indexOf("FABRIC") != -1 ) return 1 } },
              genSeName: function(rec) { return getSubelementName(rec.element, extractValue(rec, "LINKID"), "PVGFabricCard") },
              formulaPath: "AP~Specific~Bulk~Carrier VOIP~Infrastructure~Media Gateway~Fabric Card",
              Formulas: {
                  MaxTemp: { method: function(rec) { return extractValue(rec, "MAXTEMP") } }
              }
      },
      PVGShelfCard: {
              properties: { VOIPSoftswitchComponentType: "Media_Gateway_ShelfCard", VOIPSoftswitchVendor: "Nortel",
                            VOIPSoftswitchLocation: function(rec) { return extractValue(rec, "OFFICEID") } },
              // filter: function(rec) { if ( extractValue(rec, "LMBUTIL") > -1 ) return 1 },
              filter: function(rec) { var link = extractValue(rec, "LINKID"); logMessage("FILTER", link); logMessage("FILTER", link); if ( link != undefined ) { if ( link.indexOf("SHELF") != -1 ) return 1 } },
              formulaPath: "AP~Specific~Bulk~Carrier VOIP~Infrastructure~Media Gateway~Card",
              genSeName: function(rec) { return getSubelementName(rec.element, extractValue(rec, "LINKID"), "PVGShelfCard" ) },
              Formulas: {
                  CardUtilAvg: { aggr: "sum", method: function(rec) { return extractValue(rec, "CARDUTILAVG") } },
                  LMBUtil: { aggr: "sum", method: function(rec) { return extractValue(rec, "LMBUTIL") } }
              }
      },
      PVG_VSP_ProcessorCard: {
              properties: { VOIPSoftswitchComponentType: "Media_Gateway_VSP_ProcessorCard", VOIPSoftswitchVendor: "Nortel",
                            VOIPSoftswitchLocation: function(rec) { return extractValue(rec, "OFFICEID") } },
              // filter: function(rec) { if ( extractValue(rec, "VSPUTILAVG") > -1 ) return 1 },
              filter: function(rec) { var link = extractValue(rec, "LINKID"); logMessage("FILTER", "link: " + link); if ( link != undefined ) { if ( link.indexOf("VSP") != -1 ) return 1 } },
              formulaPath: "AP~Specific~Bulk~Carrier VOIP~Infrastructure~Media Gateway~VSP Processor Card",
              genSeName: function(rec) { return getSubelementName(rec.element, extractValue(rec, "LINKID"), "PVG_VSP_ProcessorCard" ) },
              Formulas: {
                   AvgCPUutilizationVSPCard: { aggr: "average", method: function(rec) {logMessage("VSPUTILAVG", "returning vsputilavg: " + extractValue(rec, "VSPUTILAVG"));  return extractValue(rec, "VSPUTILAVG") } }
              }
      },
      PVG_VSP_CallSignaling: {
              properties: { VOIPSoftswitchComponentType: "Media_Gateway_VSP_CallSignaling", VOIPSoftswitchVendor: "Nortel",
                            VOIPSoftswitchLocation: function(rec) { return extractValue(rec, "OFFICEID") } },
              // filter: function(rec) { if ( extractValue(rec, "INH248RETRAN") > -1 ) return 1 },
              filter: function(rec) { var link = extractValue(rec, "LINKID"); logMessage("FILTER", link); if ( link != undefined ) { if ( link.indexOf("VSP") != -1 ) return 1 } },
              formulaPath: "AP~Specific~Bulk~Carrier VOIP~Infrastructure~Media Gateway~VSP Call Signaling",
              genSeName: function(rec) { return getSubelementName(rec.element, extractValue(rec, "LINKID"), "PVG_VSP_CallSignaling" ) },
              Formulas: {
                   // TotalCongestionSeconds: {  method: function(rec) { return rec.CONGSECS } },
                   CongestedSeconds: {  method: function(rec) { return extractValue(rec, "CONGSECS") } },
                   Failovers: {  method: function(rec) { return extractValue(rec, "FAILOVERS") } },
                   H248Retransmission: {  method: function(rec) { return myMetricSum(extractValue(rec, "INH248RETRAN"), extractValue(rec, "OUTH248RETRAN")) } },
                   AvgActiveCalls: {  method: function(rec) { return extractValue(rec, "ACTIVECALLAVG") } },
                   MaxActiveCalls: {  method: function(rec) { return extractValue(rec, "ACTIVECALLMAX") } },
                   TotalSuccessfulCalls: {  method: function(rec) { return ( extractValue(rec, "ACTIVECALLAVG") * LOG_TYPE ) } },
                   TotalTDMCallFails: {  method: function(rec) { return extractValue(rec, "CALLFAILTDM") } },
                   TotalNetworkCallFails: {  method: function(rec) { return extractValue(rec, "CALLFAILSNET") } },
                   TotalMinutesOfUse: {  method: function(rec) { return ( extractValue(rec, "ACTIVECALLAVG") * LOG_TYPE ) } },
                   DigitRequestRejectNoResource: {  method: function(rec) { return extractValue(rec, "DIGITREJECT") } },
                   OverloadCmdRejected: {  method: function(rec) { return extractValue(rec, "OVLDCMDSREJECTED") } }
              }
      },
      PVG_Interface: {
              properties: { VOIPSoftswitchComponentType: "Media_Gateway_Interface", VOIPSoftswitchVendor: "Nortel",
                            VOIPSoftswitchLocation: function(rec) { return extractValue(rec, "OFFICEID") }, VOIPSoftswitchLinkcap: function(rec) { return extractValue(rec, "IPLINKCAP") } },
              // filter: function(rec) { if ( extractValue(rec, "OUTPACKETS") > -1 ) return 1 },
              filter: function(rec) { var link = extractValue(rec, "LINKID"); logMessage("FILTER", link); if ( link != undefined ) { if ( link.indexOf("LP/") != -1 ) return 1 } },
              formulaPath: "AP~Specific~Bulk~Carrier VOIP~Infrastructure~Media Gateway~Interface",
              genSeName: function(rec) { return getSubelementName(rec.element, extractValue(rec, "LINKID"), "PVG_Interface" ) },
              Formulas: {
                   TotalNumberOfPackets: {  method: function(rec) { return myMetricSum(extractValue(rec, "INPACKETS"), extractValue(rec, "OUTPACKETS")) } },
                   TotalNumberOfTCPPackets: {  method: function(rec) { return myMetricSum(extractValue(rec, "INTCPPACKETSLOCAL"), extractValue(rec, "OUTTCPPACKETSLOCAL")) } },
                   TotalNumberOfUDPPackets: {  method: function(rec) { return myMetricSum(extractValue(rec, "INUDPPACKETSLOCAL"), extractValue(rec, "OUTUDPPACKETSLOCAL")) } },
                   TotalNumberOfICMPPackets: {  method: function(rec) { return myMetricSum(extractValue(rec, "INICMPPACKETSLOCAL"), extractValue(rec, "OUTICMPPACKETSLOCAL")) } },
                   TotalNumberOfDiscardedPackets: {  method: function(rec) { return myMetricSum(extractValue(rec, "INPACKETSDIS"), extractValue(rec, "OUTPACKETSDIS")) } },
                   TotalNumberOfPacketExceptions: {  method: function(rec) { return myMetricSum(extractValue(rec, "INLOCALEXCEPTIONS"), extractValue(rec, "INFWDEXCEPTIONS")) } },
                   AverageInboundUtilization: {  method: function(rec) { return interfaceUtilization(extractValue(rec, "INBYTES"), extractValue(rec, "IPLINKCAP")) } },
                   AverageOutboundUtilization: {  method: function(rec) { return interfaceUtilization(extractValue(rec, "OUTBYTES"), extractValue(rec, "IPLINKCAP")) } },
                   InboundPacketRate: {  method: function(rec) { return packetRate(extractValue(rec, "INPACKETS")) } },
                   OutboundPacketRate: {  method: function(rec) { return packetRate(extractValue(rec, "OUTPACKETS")) } }
              }
      }

};





function packetRate(packetNum) {
    var logger = "packetNum: " + packetNum;
       logMessage( "packetRate", logger);
    if ( packetNum && LOG_TYPE ) {
       return ( packetNum / ( LOG_TYPE * 60 ) );
    } else {
       return 0;
    }
}





function interfaceUtilization( bytes, intCap ) {
    var logger = "bytes: " + bytes + " intCap: " + intCap;
         logMessage( "interfaceUtilization", logger);
    if ( bytes && intCap ) {
       // this line has changed for 4.3Y to address a bugfix
       return ( 100 * ( bytes / ( intCap  * 1800 )));
    } else {
       return 0;
    }
}





function getSubelementName(elem, link, type) {
   // LINKID values:
   // EM/DESIGN_6 SHELF CARD/14
   // EM/DESIGN_6 SHELFFABRICCARD/X
   // EM/DESIGN_6 LP/10 SONET/0
   // EM/DESIGN_6 LP/12 VSPPMODULE/1 PBLOCK/1
   // EM/DESIGN_6 ATMIF/1000
   // EM/DESIGN_6 LP/11 SONET/3STS/0
   // EM/DESIGN_3 NSTA/12VGS
   // EM/DESIGN_3 LP/15 ETH/1

   var linkid;
   logMessage("CREATE_SUBELEMENT_NAME", link);
   var fields;
   if ( link == undefined ) {
      return elem + "_" + type;
   }
   fields = link.split(' ');
   // var linkid = fieldBArr[1];
   // var fields = linkid.split(' ');
   fields.shift();

   if (type == "PVGDevice") {
      // linkid = fields[0] + "_" + type;
      linkid = elem + "_Device";
   } else {
      var tmpName = "";
      for ( var i = 0; i < fields.length; i++ ) {
         tmpName = tmpName + "_" + fields[i];
         logMessage("NAME_NOW:", elem + tmpName);
      }
      linkid = elem + tmpName;
      if ( type.indexOf("ProcessorCard") != -1 ) {
         linkid = linkid + "_ProcessorCard";
      }
   }

   var logger = "getSubelementName: " + linkid;
   logMessage( "getSubelement", logger);
   return linkid;

}      
       


 
 
function sumCallFailures(rec, direction) {
      if ( direction == "out" ) {
         return extractValue(rec, "OUTFAIL17") + extractValue(rec, "OUTFAIL18") + extractValue(rec, "OUTFAIL21") + extractValue(rec, "OUTFAIL27") + extractValue(rec, "OUTFAIL28");
      } else if ( direction == "in" ) {
         return extractValue(rec, "INFAIL17") + extractValue(rec, "INFAIL18") + extractValue(rec, "INFAIL21") + extractValue(rec, "INFAIL27") + extractValue(rec, "INFAIL28");
      }
      return 0;
}
 



 
function myMetricSum(metric1, metric2) {
    if ( metric1 && metric2 ) {
        logMessage( "MY_METRIC_SUM", Number( metric1 + metric2 ) );
        return Number( metric1 + metric2 );
    } else {
        return undefined;
	// return 0;
    }
}



/*
function findLabel(label) {
   for ( var l in labelArray ) {
      if ( labelArray[l] == label ) {
         return 1;
      }
   }
}

*/

function findLabel(label) {
    var index=-1;
    index=labelHash[label];
    if (index >= 0) {
	return 1;
    }
}

 

// ***********************************************************************
// *  In ProcessRecord Below I added an if statement to stop the inventory
// *  process if it is PVGDevice  if(deviceType != 'PVGDevice'
// * - Luis Jan 2012
 
function processRecord(record) {
    logMessage("PROCESS_RECORD", "Begin process record...");
    logMessage("PROCESS_RECORD", "  record: " + record);

    //  Record(fields:0,NGSS_MCS,0,0,0,0,0,0,0,0,0,0,0,0,0, 
    //    labelArray:Key,KeyName, IC_CALL_ATTEMPTS,OG_CALL_ATTEMPTS,CALLS_ABANDONED,CALLS_ANSWERED,CALLS_REJECTED,CALLS_REDIRECTED,OVRLD_CALLS_REJECTED,DPT_TID_OVFL,SIPGW_CALLP_SPARE_1,SIPGW_CALLP_SPARE_2,SIPGW_CALLP_SPARE_3,SIPGW_CALLP_SPARE_4,SIPGW_CALLP_SPARE_5, 
    //    valueArray:0,  NGSS_MCS,0,0,0,0,0,0,0,0,0,0,0,0,0, 
    //    timestamp:2009.03.25-00.28.00[1237940880], 
    //    element:47.142.130.155-COM2NGSS0,  
    //    entityType:SessionServer )

    if (record.fields[0] == "PMFile=End") {
	processDevRecord(inputDescriptor);
	return;
    }

    logMessage("ELEMENT", "Creating element with name: " + record.element);
    var elmt = operator.elementNamedOrNew(record.element);
    elmt.state = true;
    elmt.origin = "CPRAdaptor";
    elmt.timestamp = record.timestamp;
   
    // var sename = record.element + '_Device' 
    for ( var deviceType in deviceMetrics ) {
       if ( deviceMetrics[deviceType].filter(record) == 1 ) {
          record.entityType = deviceType;
          logMessage("genSeName", "record.entityType: "  + record.entityType);
          //if (deviceType != 'PVGDevice') {
          	var sename = deviceMetrics[record.entityType].genSeName(record);
          	logMessage("SUBELEMENT", "Creating subelement with name: " + sename);
          	var se = operator.subelementNamedOrNew(sename);
          	se.state = true;
          	se.invariant = sename;
          	se.instance = sename;
          	se.family = "VOIP_Softswitch";
          	se.label = sename;
          	se.timestamp = record.timestamp;
          	se.origin = "CPRAdaptor";
          	for ( var property in deviceMetrics[record.entityType].properties ) {
             logMessage("property:label = '" + property + "' and value = '" + deviceMetrics[record.entityType].properties[property] + "'",  "addProperty");
             if ( typeof deviceMetrics[deviceType].properties[property] == "function" ) {
                 se.addProperty(property.toString(), deviceMetrics[deviceType].properties[property](record, property));
             } else {
                 se.addProperty(property.toString(), deviceMetrics[deviceType].properties[property]);
             }
          }
          se.element = elmt;
//}
      
          for ( var form in deviceMetrics[record.entityType].Formulas ) {
               logMessage( "SUBELEMENT_ADDED: FORM: ", form);
               logMessage( "SUBELEMENT_ADDED", "2");
              // var val = deviceMetrics[record.entityType].Formulas[form].method(record);
               var val = deviceMetrics[record.entityType].Formulas[form].method(record, form);
	logMessage( "SUBELEMENT_ADDED", "3");
               if ( val == 0 || val > 0 ) {
                  logMessage( "SUBELEMENT_ADDED", "4");
                  metric = operator.FloatMetric();
                  metric.resource = se;
                  logMessage( "SUBELEMENT_ADDED", "5");
                  logMessage( "PROCESSING METRIC", metric);
                  // metric.name = deviceMetrics[record.entityType].formulaPath + "~" + record.entityType + "~" + form;
                  metric.name = deviceMetrics[record.entityType].formulaPath + "~" + form;
                  logMessage( "PROCESSING METRIC_NAME", deviceMetrics[record.entityType].formulaPath + "~" + record.entityType + "~" + form);
                  // metric.timestamp = lastdateobject;
                  metric.timestamp = record.timestamp;
                  logMessage( "PROCESSING METRIC_TIMESTAMP", metric);
                  // metric.value = deviceMetrics[record.entityType].Formulas[form].method(record);
                  metric.value = val;
                  logMessage( "PROCESSING METRIC_VALUE", metric);
                  operator.addMetric(metric);
                  logMessage( "ADDING_METRIC_TO_MODELINTF",  metric);
              }
          }
       }
   }

}


// ***********************************************************************
// *  I added this to handle just the PVGDevice metrics only.
// *  
// * - Luis Jan 2012

function processDevRecord(inputDescriptor) {
    //PV.Logger.logInfo("processDEvRecord: ", "ENTERING", "onClose");
    logMessage("PROCESS_DEV_RECORD", "Begin process record...");
    logMessage("PROCESS_DEV_RECORD", "  record: " + record);
    //var newelmt = storeDev.newelmt;
    var deviceType = 'PVGDevice';
    var elmt;
    var val;
    var formpath = "AP~Specific~Bulk~Carrier VOIP~Infrastructure~Media Gateway~Device~";
    var storedSE;

    //PV.Logger.logInfo("processDevRecord", "inputDescriptor ", inputDescriptor);
    //PV.Logger.logInfo("processDevRecord", "DUMPING the STOREDEV", storeDev.toString());
	//PV.Logger.logInfo("processDevRecord: ", "loop", "about to enter the loop");

    if (storeDev_initialized == true ) {
	    //PV.Logger.logInfo("processDevRecord", "STOREDEV", " is initialized");
    for ( var subelement in storeDev ) {

	//PV.Logger.logInfo("processDevRecord: ", "loop", "entering the loop");

	        storedSE=storeDev[subelement];
		sename = storedSE.name;
		//PV.Logger.logInfo("processDevRecord", "Creating subelement with name: " + sename);
		//PV.Logger.logInfo("processDevRecord", "storedSE: " + storedSE);
		//PV.Logger.logInfo("processDevRecord", "storeDEv[storedSE].name: " + storedSE.name);

		elmt = operator.elementNamedOrNew(storedSE.element);
		elmt.state = true;
		elmt.origin = "CPRAdaptor";
		elmt.timestamp = storedSE.timestamp;

          	var se = operator.subelementNamedOrNew(sename);
          	se.state = true;
          	se.invariant = sename;
          	se.instance = sename;
          	se.family = "VOIP_Softswitch";
          	se.label = sename;
          	se.timestamp = storedSE.timestamp;
          	se.origin = "CPRAdaptor";
		//PV.Logger.logInfo("processDevRecord", "Before properties ");
          	for ( var property in storedSE.properties ) {
		    se.addProperty(property.toString(), storedSE.properties[property]);
		    //PV.Logger.logInfo("processDevRecord", "Property added from: " + property.toString());
		//PV.Logger.logInfo("processDevRecord", "Property added val: " + storedSe.properties[property]);
		    
		}
		//PV.Logger.logInfo("processDevRecord", "After properties ");

		se.element = elmt;
      
          for ( var form in storedSE.metrics) {
               logMessage( "METRIC_ADDED: FORM: ", form);
		//PV.Logger.logInfo("processDevRecord", "Metric added from: " + form);
		   val = storedSE.metrics[form];
		//PV.Logger.logInfo("processDevRecord", "Metric added val: " + val);
               if ( val == 0 || val > 0 ) {
                  metric = operator.FloatMetric();
                  metric.resource = se;
                  metric.name = formpath + form;
                  metric.timestamp = storedSE.timestamp;
               logMessage( "SUBELEMENT_ADDED: TIMESTAMP: ", storedSE.timestamp);
                  metric.value = val;
                  operator.addMetric(metric);
	       }
          } // metrics
    } // for storedSE

    // clear it out for the next file
    storeDev=new Object();
    storeDev_initialized = false;

    } else { // storeDev not initialized
	//PV.Logger.logInfo("processDevRecord", "STOREDEV", " not initialized");
	return;
    }


    //PV.Logger.logInfo("processDevRecord", "exiting ");

}

function preProcessRecord(record) {
    logMessage("PRE_PROCESS_RECORD", "record: " + record);
//	PV.Logger.logInfo("I am in preProcessRecord", "PRE_PROCESS_RECORD:", record);
// The next two lines were added by Luis Feb 2012
//	storeDev = new Object();
//	storeDev.devMetArray = new Array();
    if ( lastMessage == "SystemId" ) {
       entityType = record.fields[0];
    } else if ( lastMessage == "EntityId" ) {
       element = record.fields[0];
    } else if ( lastMessage == "Label" ) {
	//       labelArray = record.fields;
       labelHashInit(record);
       if ( findLabel("LINKID") ) {
           entityType = "PVG";
       }
    } else if ( lastMessage == "Value" ) {
	record.labelHash = labelHash;
	//       record.labelArray = labelArray;
	//       record.valueArray = record.fields;
       // record.timestamp = lastdateobject.asUTCSeconds();
       record.element = element;
       record.entityType = entityType;
       logMessage("RETURN_RECORD", record);
       lastMessage = record.fields[0];
       return record;
    } else if (record.fields[0] == "PMFile=End") {
	return record;
	// This will signal to processRecord to write out the Device metrics that have been aggregated throughout the file
    } else if ( record.fields.length > 1 ) {
       if ( labelHash && record.fields[0] != "Value"  ) {
	   //       if ( labelArray && record.fields[0] != "Value"  ) {
          // we probably have another row of values 
          record.entityType = entityType;
          record.element = element;
	  record.labelHash = labelHash;
	  //          record.labelArray = labelArray;
	  //          record.valueArray = record.fields;
          // record.timestamp = lastdateobject.asUTCSeconds();
          logMessage("RETURN_RECORD", record);
          lastMessage = record.fields[0];
          return record;
       }
    }
    lastMessage = record.fields[0];
    return null;
}

// ***********************************************************************
// *  This is added to start a new Array each time it starts to process a new file
// *  and is kicked off with the onOpen line in the schema below
// * - Luis Jan 2012
// ***********************************************************************

function openNewArray(inputDescriptor) { 
	logMessage("IN_OPEN_NEWARRAY", "I am in onOpen, here is the record: " + record);
	//PV.Logger.logInfo("I am in onOpen", "OPEN_NEW_ARRAY:", inputDescriptor);
	//devMetArray = new Array();
	storeDev = new Object();
	//	storeDev.devMetArray = new Array();
}

// ***********************************************************************
// *  Define the schema and starts the processing
// ***********************************************************************

logMessage("STATUS", "Initializing schemas...");

var schema=PV.TextInputSchema(
          "CPR", { 
	    multiFileJoin: true,
	    // holdGatePeriod: 1,
            filePeriod: 900,
	    //		onOpen:  function (inputDescriptor) {openNewArray(inputDescriptor)}, 
	    //        onOpen:  function (inputDescriptor) {	PV.Logger.logInfo("ONOPEN", "Just ran onOpen" )}, 
	    // onClose: function (inputDescriptor) {processDevRecord(inputDescriptor)},
            parseURI: function (inputDescriptor) {
                 // NGSS.COM2NGSSO.OMs.TRAF_OMs.QoS.2009.03.10_17.51_GMT.csv 
                 // MDM.10.26.239.11-MDM-Mgr-Unit-0_VPPP15K1-MDM.OMs.Proviso_PMDM_Report.2009.04.24_15.23.43_GMT.csv
                 var fields = inputDescriptor.localName.split("_");
                 fields.pop();
                 var timeComplete = fields.pop();
                 var dateComplete = fields.pop();
                 var timeArr = timeComplete.split(".");
                 var hour = timeArr[0];
                 var minute = timeArr[1];
                 var dateArr = dateComplete.split(".");
                 var day = dateArr.pop();
                 var month = dateArr.pop();
                 month = month - 1;
                 var year = dateArr.pop();

                 logMessage("date fields", "year: " + year + " month: " + month + " day: " + day + " hour: " + hour + " minute: " + minute);
      
                 lastdateobject = new Date(year, month, day, hour, minute, 0);
                 logMessage("lastdateobject", lastdateobject);
                 inputDescriptor.timestamp=lastdateobject;
                 logMessage("inputDescriptor", inputDescriptor.timestamp);
             }
	    },
          PV.DelimitedRecordSchema(
              "recordSchema", 
              {  
                  fieldSeparator: ",", 
                  recordSeparator: "\r", 
                  maxOccurs: Infinity, 
                  hasHeaderRecord: false,
                  onRead: function(record) { 
	               // var date=parseDate(record.date);
                       // record.parsedDate=date;
		       // record.timestamp=date.asUTCSeconds();
                       logMessage("lastdateobject in recordschema", lastdateobject);
                       // record.timestamp = lastdateobject.asUTCSeconds();
                       record.timestamp = PV.currentInputDescriptor.timestamp.asUTCSeconds();
                       logMessage("entering pre-process", "pre-process");

                       var r = preProcessRecord(record);
                       if ( r != null ) {
                           logMessage("Emitting tuple r", r);
                           this.emitTuple(r);   
                       }
                  } 
              },
              PV.StringFieldSchema( "fields", { minOccurs: 1, maxOccurs: 6, collect: true })
          )
      );
if ( DEBUG == "true" ) {
   // schema.traceAll = true;
}
/*
 * A root operator is required with a schema and a handler function
 * StreamQuery handles one schema.
 * We have also initialized this pack for in band inventory since we will also be doing inventory
 */
var operator = PV.StreamQuery("main", schema, processRecord);
if ( DEBUG == "true" ) {
   // operator.traceAll = true;
}
operator.initializeForInbandInventory();
